//+------------------------------------------------------------------+
//|                                             Taariqmartingale.mq4 |
//|                        Copyright 2022, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
//Where i copied it from "https://youtu.be/cKJweUr0fTw"//

#property copyright "Copyright 2022, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
/////////////////////////////////////////////////Variables

input int InpMaxTrades = 5; //max number of trades
input double InpTradeGap = 0.005; //minimum gap between trades
input ENUM_ORDER_TYPE InpType = ORDER_TYPE_BUY; //Order type
input ENUM_ORDER_TYPE InpType2 = ORDER_TYPE_SELL; //Order type
input double InpMinProfit = 1.00; //profit in base currency
input int InpMagicNumber = 1111; //magic number
input string InpTradeComment = __FILE__; //Trade comment
input double InpVolume = 0.01; //Volume per order
input double Stoploss = 10;

input int    MovingPeriod  =200;
input int    MovingShift   =1;

////////////////////////////////////////////A structure (struct) is a set of elements of any type (except for the void type)

struct STradeSum 
{
   int count;
   double profit;
   double trailPrice;
};

///////////////////////////////////////////////

void OnTick() 
{
   
STradeSum  sum;
GetSum(sum);
    
   if (sum.profit>InpMinProfit) { CloseAll(); } // target reached
    
   else
   
   if (sum.count==0) { OpenTrade(); } // no trades 
   
   else
   
   if (sum.count<InpMaxTrades) 
   {
      if (InpType==ORDER_TYPE_BUY && SymbolInfoDouble(Symbol(), SYMBOL_ASK)<=(sum.trailPrice-InpTradeGap)) {   // Far enough below
         OpenTrade();} 
         
      else
      
      if (InpType2==ORDER_TYPE_SELL && SymbolInfoDouble(Symbol(), SYMBOL_BID)>=(sum.trailPrice+InpTradeGap)) {   // Far enough above
         OpenTrade();
      }
   }
       
}

/////////////////////////////////////////////////////////This is how the trades open
void  OpenTrade() 
 {
     
   double ma;
   int    res;
   
   ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);
     
   if(Open[1]>ma && Close[1]<ma)
   {
   double   price =  (InpType==ORDER_TYPE_BUY) ?
                        SymbolInfoDouble(Symbol(), SYMBOL_ASK):
                        SymbolInfoDouble(Symbol(), SYMBOL_BID);
   res=OrderSend(Symbol(), InpType, InpVolume, price, 0, Stoploss, 0, InpTradeComment, InpMagicNumber);
   }
   else
   if(Open[1]<ma && Close[1]>ma)
   {
   double   price2 =  (InpType2==ORDER_TYPE_SELL) ?
                        SymbolInfoDouble(Symbol(), SYMBOL_ASK):
                        SymbolInfoDouble(Symbol(), SYMBOL_BID);
   res=OrderSend(Symbol(), InpType2, InpVolume, price2,0, Stoploss, 0, InpTradeComment, InpMagicNumber);
   }
 }
  

////////////////////////////////////////////////////This is how the trades are closed
void  CloseAll() 
{
   int   count    =  OrdersTotal();
   for (int i = count-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (  OrderSymbol()==Symbol()
               && OrderMagicNumber()==InpMagicNumber
               && OrderType()==InpType || OrderType()==InpType2
               ) {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0);
         }
      }
   }
}

//////////////////////////////////////////////////////////
void  GetSum(STradeSum &sum) {
   sum.count      =  0;
   sum.profit     =  0.0;
   sum.trailPrice =  0.0;
    
   int   count    =  OrdersTotal();
   for (int i = count-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (  OrderSymbol()==Symbol()
               && OrderMagicNumber()==InpMagicNumber
               && OrderType()==InpType || OrderType()==InpType2
               ) {
            sum.count++;
            sum.profit  += OrderProfit()+OrderSwap()+OrderCommission();
            if (InpType==ORDER_TYPE_BUY) {
               if (sum.trailPrice==0 || OrderOpenPrice()<sum.trailPrice) {
                  sum.trailPrice =  OrderOpenPrice();
               }
            } else
            if (InpType2==ORDER_TYPE_SELL) {
               if (sum.trailPrice==0 || OrderOpenPrice()>sum.trailPrice) {
                  sum.trailPrice =  OrderOpenPrice();
               }
            }
         }
      }
   }
    
   return;
    
}
